#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#define d double
#define ESTIMATE(O, N) ((O) - (N)) * SIX + (N) * (PI + E)

d SIX = 6.00000000000000000000000000000000000000000000000000000000000000000000;
d PI  = 3.14159265358979323846264338327950288419716939937510582097494459230781;
d E   = 2.71828182845904523536028747135266249775724709369995957496696762772407;

int main(int argc, char** argv) {
    if(argc != 2) {
        printf("Please provide one target number.\n");
        return -1;
    }

    d target = strtod(argv[1], NULL);

    if(fmod(target, SIX) == 0) {
        printf("%f * 6 = %f\n", target / SIX, target);
        return 0;
    }

    /*          M E T A S T A C K          */
    d n = 0;
    d overestimate = ceil(target / SIX);
    while(ESTIMATE(overestimate, n) > target) {
        n++;
    }

    d above = ESTIMATE(overestimate, n - 1);
    d below = ESTIMATE(overestimate, n);
    if(target - below < above - target) {
        printf("%f * 6 + %f * (pi + e) = %f\n", overestimate - n, n, below);
        return 0;
    }

    printf("%f * 6 + %f * (pi + e) = %f\n", overestimate - n - 1, n - 1, below);
    return 0;
}
